<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="generator" content="Docutils 0.21.2: https://docutils.sourceforge.io/" />
<title>absorb</title>
<link rel="stylesheet" href="../style.css" type="text/css" />
</head>
<body>
<div class="document" id="absorb">
<span id="ext-absorb"></span>
<h1 class="title">absorb</h1>

<div class="contents htmlonly topic" id="contents">
<p class="topic-title"><a class="reference internal" href="#top">Contents</a></p>
<ul class="simple">
<li><a class="reference internal" href="#description" id="toc-entry-1">Description</a></li>
<li><a class="reference internal" href="#commands" id="toc-entry-2">Commands</a><ul>
<li><a class="reference internal" href="#change-creation" id="toc-entry-3">Change creation</a></li>
</ul>
</li>
</ul>
</div>
<p>apply working directory changes to changesets (EXPERIMENTAL)</p>
<div class="section" id="description">
<h1><a class="toc-backref" href="#contents">Description</a></h1>
<p>The absorb extension provides a command to use annotate information to
amend modified chunks into the corresponding non-public changesets.</p>
<pre class="literal-block">
[absorb]
# only check 50 recent non-public changesets at most
max-stack-size = 50
# whether to add noise to new commits to avoid obsolescence cycle
add-noise = 1
# make `amend --correlated` a shortcut to the main command
amend-flag = correlated

[color]
absorb.description = yellow
absorb.node = blue bold
absorb.path = bold
</pre>
</div>
<div class="section" id="commands">
<h1><a class="toc-backref" href="#contents">Commands</a></h1>
<div class="section" id="change-creation">
<h2><a class="toc-backref" href="#contents">Change creation</a></h2>
<div class="section" id="absorb-1">
<h3>absorb</h3>
<p>incorporate corrections into the stack of draft changesets:</p>
<pre class="literal-block">
hg absorb [OPTION] [FILE]...
</pre>
<p>absorb analyzes each change in your working directory and attempts to
amend the changed lines into the changesets in your stack that first
introduced those lines.</p>
<p>If absorb cannot find an unambiguous changeset to amend for a change,
that change will be left in the working directory, untouched. They can be
observed by <a class="reference external" href="hg-status.html"><tt class="docutils literal">hg status</tt></a> or <a class="reference external" href="hg-diff.html"><tt class="docutils literal">hg diff</tt></a> afterwards. In other words,
absorb does not write to the working directory.</p>
<p>Changesets outside the revset <cite>::. and not public() and not merge()</cite> will
not be changed.</p>
<p>Changesets that become empty after applying the changes will be deleted.</p>
<p>By default, absorb will show what it plans to do and prompt for
confirmation.  If you are confident that the changes will be absorbed
to the correct place, run <a class="reference external" href="hg-absorb.html"><tt class="docutils literal">hg absorb <span class="pre">-a</span></tt></a> to apply the changes
immediately.</p>
<p>Returns 0 on success, 1 if all chunks were ignored and nothing amended.</p>
<p>Options:</p>
<table class="docutils option-list" frame="void" rules="none">
<col class="option" />
<col class="description" />
<tbody valign="top">
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-a</span>, <span class="option">--apply-changes</span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>apply changes without prompting for confirmation</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-p</span>, <span class="option">--print-changes</span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>always print which changesets are modified by which changes</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-i</span>, <span class="option">--interactive</span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>interactively select which chunks to apply</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-e</span>, <span class="option">--edit-lines</span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>edit what lines belong to which changesets before commit (EXPERIMENTAL)</td></tr>
<tr><td class="option-group">
<kbd><span class="option">-n</span>, <span class="option">--dry-run</span></kbd></td>
<td>do not perform actions, just print output</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">--style <var>&lt;STYLE&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>display using template map file (DEPRECATED)</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-T</span>, <span class="option">--template <var>&lt;TEMPLATE&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>display with template</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-I</span>, <span class="option">--include <var>&lt;PATTERN[+]&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>include names matching the given patterns</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-X</span>, <span class="option">--exclude <var>&lt;PATTERN[+]&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>exclude names matching the given patterns</td></tr>
</tbody>
</table>
<p>[+] marked option can be specified multiple times</p>
</div>
</div>
</div>
</div>
</body>
</html>
